\chapter{Most Relevant Classes and their Methods}
%\vspace{-6.5pc}
This list of classes and methods shows the most relevant ones, which have 
been considered in this guide. It is an excerpt from the ROOT 
\href{http://root.cern.ch/drupal/content/reference-guide}
{class reference guide}. 

\vspace{1pc}

\begin{tiny}
%
\noindent
\href{http://root.cern.ch/root/html/TGraphErrors.html}{\bf TGraphErrors}: the graph class with error bars \\
\begin{tabular} {ll}
create Graph frm file
    & \verb|TGraphErrors(const char* filename, const char* format = "%lg %lg %lg %lg", Option_t* option = "")| \\
create graph fom C-arrays    & \verb|TGraphErrors(Int_t n, const Float_t* x, const Float_t* y, const Float_t* ex = 0, const Float_t* ey = 0) |\\
create graph from histogram 
    & \verb|TGraphErrors(const TH1* h) |\\
fit a function 
    & \verb|.Fit(TF1* f1, Option_t* option = "", Option_t* goption = "", Axis_t xmin = 0, Axis_t xmax = 0) |\\
    & \verb|.Fit(const char* formula, Option_t* option = "", Option_t* goption = "", Axis_t xmin = 0, Axis_t xmax = 0) |\\
draw  
    & \verb|.Draw("AP") | and \verb|.DrawClone("AP") |\\
draw options 
    & methods of classes \verb|TGraph|, \verb|TGraphPainter|\\ 
 \end{tabular}\\[0.3pc]
%
\href{http://root.cern.ch/root/html/TH1F.html}{\bf TH1F}: the histogram class with float bin contents \\
 \begin{tabular} {ll}
create (``book'') histogram & \verb|TH1F(const char* name, const char* title, Int_t nbinsx, Double_t xlow, Double_t xup)|\\
store also squared weights & \verb|.Sumw2()|\\
fill a value & \verb|.Fill(Double_t x) |\\
fill with weight & \verb|.Fill(Double_t x, Double_t w) |\\
set bin content  & \verb|.SetBinContent(Int_t bin, Double_t content)|\\
get bin content  & \verb|Double_t .GetBinContent(Int_t bin) const|\\
fill with random numbers & \verb|.FillRandom(const char* fname, Int_t ntimes)|\\
clear & \verb|.Reset()|\\
copy to C-array &\verb|Float_t* .GetArray()|\\
set maximum on y-axis & \verb|.SetMaximum(Double_t ymax)|\\
set minimum on y-axix & \verb|.SetMinimum(Double_t ymin)|\\
get mean & \verb|Double_t GetMean(1)| \\  
get RMS  & \verb|Double_t GetRMS(1)| \\  
draw & \verb|.Draw(Option_t* option = "")|\\
useful draw options & "SAME" "E" "P" \\
    & see documentation of class \verb|THistPainter|\\ 
\end{tabular}\\[0.3pc]
%
\href{http://root.cern.ch/root/html/TH2F.html}{\bf TH2F}: 2-dimensional histogram class with float bin contents \\
 \begin{tabular} {ll}
book 
& \verb| TH2F(const char* name, const char* title, Int_t nbinsx, Double_t xlow, Double_t xup, Int_t nbinsy, Double_t ylow, Double_t yup)|\\
fill  & \verb|Fill(Double_t x, Double_t y)|\\
fill with weight & \verb|Fill(Double_t x, Double_t y, Double_t w)|\\
get mean along axis \verb|i| & \verb|Double_t GetMean(i)| \\  
get RMS  along axis \verb|i| & \verb|Double_t GetRMS(i)| \\
get covariance &  \verb|Double_t GetCovariance()| \\
get correlation &  \verb|Double_t GetCorrelationFactor()| \\
draw & \verb|.Draw(Option_t* option = "")| and \verb|.DrawClone| \\
useful draw options    & "" "SAME" "BOX" "COL" "LEGO" "SURF" \\
    & see documentation of class \verb|THistPainter|\\ 
 \end{tabular}\\[0.3pc]
%
\href{http://root.cern.ch/root/html/TH2F.html}{\bf TProfile}: "profile representation" for 2-dim histograms\\
 \begin{tabular} {ll}
book profile histogram & \verb|TProfile(const char* name,const char* title,Int_t nbinsx,Double_t xlow,Double_t xup,Double_t ylow,Double_t yup,Option_t* option = "")|\\
fill a value & \verb|.Fill(Double_t x) |\\
fill with weight & \verb|.Fill(Double_t x, Double_t w) |\\
draw & \verb|.Draw()| and \verb|.DrawClone()|
 \end{tabular}\\[0.3pc]
%
\href{http://root.cern.ch/root/html/TF1.html}{\bf TF1}: the mathematical function \\
 \begin{tabular} {ll}
define function in \verb|TFormula| syntax
  & \verb|TF1(const char* name, const char* formula, Double_t xmin = 0, Double_t xmax = 1)|\\
predefined functions & "gaus" "expo" "pol0" ... "pol9" "landau" \\
define function via pointer  
  & \verb|TF1(const char* name, void* fcn, Double_t xmin, Double_t xmax, Int_t npar)|\\
evaluate at x & \verb|.Eval(Double_t x) |\\
calculate derivative & \verb|Double_t .Derivative(Double_t x) |\\
calculate integral a to b  & \verb|Double_t .Integral(Double_t a, Double_t b) |\\
get random number & \verb|Double_t .GetRandom()|\\
set parameter \verb|i|
 & \verb|.SetParameter(Int_t i, Double_t parvalue) |\\
set parameters & \verb|.SetParameters(const Double_t* params)|\\
fit function \verb|*f| to graph \verb|*gr| or histogram \verb|*h|  
  & \verb|gr->Fit(TF1 *f)| or h->Fit(TF1 *f)|\\
get parameter \verb|i| & \verb|Double_t .GetParameter(Int_t i)|\\
get error on parameter \verb|i| & \verb|Double_t .GetParError(Int_t i)|\\
 \end{tabular}\\[0.3pc]
%
\href{http://root.cern.ch/root/html/TRandom3.html}{\bf TRandom3}: the calss used to generate random sequences of high quality\\
 \begin{tabular} {ll}
initialize random generator with random seed & \verb|TRandom(0)|\\
initialize random generator with seed & \verb|TRandom(UInt_t seed)|\\
get actual seed & \verb|UInt_t .GetSeed()|\\
uniform random number \verb|]0,x1]|
    &\verb|Double_t .Uniform(Double_t x1=1)|\\
uniform random number \verb|]x1,x2]|
  & \verb|Double_t .Uniform(Double_t x1, Double_t x2) |\\
random number from binomial distribution  & \verb|Int_t .Binomial(Int_t ntot, Double_t prob)|\\
random Poisson number & \verb|Int_t .Poisson(Double_t mean) |\\
random number from exponential & \verb|Double_t .Exp(Double_t tau) |\\
random number from Gaussian distribution & \verb|Double_t .Gaus(Double_t mean=0, Double_t sigma=1)|\\
pre-initialised random generator & \verb|gRandom| points to global instance of \verb|TRandom3|\\
 \end{tabular}\\[0.3pc]
%
\href{http://root.cern.ch/root/html/TCanvas.html}{\bf TCanvas}: configuring the graphics canvas\\
 \begin{tabular} {ll}
create canvas of size \verb|ww x wh|
  & \verb|TCanvas(const char* name, const char* title, Int_t ww, Int_t wh)|\\ 
subdivide into pads 
&\verb|.Divide(Int_t nx = 1, Int_t ny = 1, Float_t xmargin = 0.01, Float_t ymargin = 0.01, Int_t color = 0)|\\ 
chage to subpad & \verb|.cd(Int_t subpadnumber = 0)|\\
update canvas & \verb|.Update()|\\
mark as modified to trigger re-draw &\verb|.Modified(Bool_t flag = 1)|\\
draw canvas & \verb|.Draw(Option_t* option = "")| and \verb|.DrawClone|\\
\end{tabular}\\[0.3pc]
%
\href{http://root.cern.ch/root/html/TLegend.html}{\bf TLegend}: the legend in a plot. Fundamental for the understanding of the contents \\
 \begin{tabular} {ll}
create Legend & \verb|TLegend(Double_t x1,Double_t y1,Double_t x2,Double_t y2,const char* header, Option_t* option = brNDC)|\\
add an entry & \verb|.AddEntry(TObject* obj, const char* label, Option_t* option = lpf)|\\
add text entry & \verb|.AddEntry(const char* name, const char* label, Option_t* option = lpf)|\\
draw        & \verb|.Draw()| and \verb|.DrawClone();|\\
 \end{tabular}\\[0.3pc]
%
\href{http://root.cern.ch/root/htmldoc/TLatex.html}{\bf TLatex}: LaTEX formatting \\
 \begin{tabular} {ll}
create Text & \verb|TLatex(Double_t x, Double_t y, const char* text)|\\
draw        & \verb|.Draw()| and \verb|.DrawClone();|\\
 \end{tabular}\\[0.3pc]
%
\href{http://root.cern.ch/root/htmldoc/TFile.html}{\bf TFile}: file I/O\\
 \begin{tabular} {ll}
create file 
   & \verb|TFile(const char* fname, Option_t* option = "", const char* ftitle = "", Int_t compress = 1)|\\
   & options " NEW" "CREATE" "RECREATE" "READ" \\ 
change direcotry to fle & \verb|.cd()| \\
write histogram \verb|*h| to file & \verb|h1->Write()| \\
close file at the end & \verb|.Close()| \\
read histogram \verb|*h| from file \verb|*f| 
 & TH1F *h1=(TH1F*)f.Get(const char* histname) \\
 \end{tabular}\\[0.3pc]
%
\href{http://root.cern.ch/root/htmldoc/TFile.html}{\bf TNtuple}: variables in ntuples\\
 \begin{tabular} {ll}
create & \verb|TNtuple(const char* name, const char* title, const char* varlist)|\\
        & format varlist: \verb|"x0:x2:...:xn"| (n<15) \\
fill    & \verb|.Fill(Float_t x0,Float_t x1=0,Float_t x2=0, ... ,Float_t x14=0)| \\
initialize from file	&\verb|.ReadFile(const char* filename)|\\
plot variables &\verb|.Draw(const char* varexp, const char* selection)|\\
~~e.g. plot variable \verb|xi| & \verb|.Draw("xi")|\\
~~e.g. plot variable with cut on others & \verb|.Draw("xi","xj<3")|\\
~~e.g. 2-dim plot of variables \verb|xi| and \verb|xj| & \verb|.Draw("xi:xj")|\\
fill existing histogram from ntuple & \verb|.Project(const char* hname, const char* varexp, const char* selection = "")|
\end{tabular}\\[0.3pc]
%
global pointers \verb|gStyle| and \verb|gSystem| as instances of classes 
        \href{http://root.cern.ch/root/html/TStyle.html}{\bf TStyle} and 
        \href{http://root.cern.ch/root/html/TSystem.html}{\bf TSystem} \\
 \begin{tabular} {ll}
show statistics box &\verb|gStyle->SetOptStat(11...1)| \\
show fit parameters in statistics box &\verb|gStyle->SetOptFit(11...1)|\\
suppress title boxes on graphs and histograms &\verb|gStyle->SetOptTitle(0)|\\
for animations: add pause in milliseconds & \verb|gSystem->Sleep(UInt_t t)|\\
\end{tabular}\\[0.3pc]
%
\href{http://root.cern.ch/root/htmldoc/TVirtualFitter.html}{\bf TVirtualFitter}: Fitting\\
 \begin{tabular} {ll}
set default fitter, e.\,g. \verb|name="Minuit"| & \verb|TVirtualFitter::SetDefaultFitter("(const char* name = "")|\\
create Fitter instance & \verb|TVirtualFitter::Fitter(0,Int_t maxpar=25); |\\
define a parameter  & \verb|Int_t .SetParameter(Int_t ipar,const char* parname,Double_t value,Double_t verr,Double_t vlow,Double_t vhigh)|\\
set function to be minimized  & \verb|.SetFCN(void (*)(Int_t&, Double_t*,Double_t&f,Double_t*,Int_t) fcn)|\\
fix a parameter & \verb|.FixParameter(Int_t ipar)|\\
release parameter & \verb|.ReleaseParameter(Int_t ipar)|\\
get pointer to active fitter instance & \verb|static TVirtualFitter* .GetFitter() |\\
interaction with fitter & \verb|Int_t .ExecuteCommand(const char* command, Double_t* args, Int_t nargs)| \\
\hfill example: start fit with MINUIT:  & \verb| double arglist[2]={5000,0.01}; .ExecuteCommand("MINIMIZE",arglist,2)|\\
\hfill  example: error evaluation MINUIT / MINOS: & \verb|ExecuteCommand("MINOS",arglist,0)|\\  
get pointer to covariance matrix & \verb|Double_t* .GetCovarianceMatrix() const |\\
\end{tabular}\\
interaction with MINUIT via global pointer gMinuit of class \href{http://root.cern.ch/root/htmldoc/TVirtualFitter.html}{\bf TMinuit}\\
\begin{tabular} {ll}
set DeltaChi2 value for error determination &\verb|gMinuit->SetErrorDef(float DeltaChi2)|\\
get coutour line as \verb|TGraph| & \verb|(TGraph*)gMinuit->Contour(npoints, int par1, int par2)|\\
\end{tabular}\\
%
\end{tiny}
